;;; Assembler source for FPA support code and emulator - PIE veneer
;;; Pre-core part.
; Copyright (C) Advanced RISC Machines Limited, 1992-7 (now named ARM Limited).
; All rights reserved.
;
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions are met:
;
;     * Redistributions of source code must retain the above copyright notice,
;       this list of conditions and the following disclaimer.
;     * Redistributions in binary form must reproduce the above copyright
;       notice, this list of conditions and the following disclaimer in the
;       documentation and/or other materials provided with the distribution.
;     * Neither the name of Advanced RISC Machines Limited nor ARM Limited nor
;       the names of its contributors may be used to endorse or promote
;       products derived from this software without specific prior written
;       permission.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
; ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
; LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
; CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
; SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
; CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
; ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; POSSIBILITY OF SUCH DAMAGE.

        GBLS    Temp
        GBLS    VBar
VBar    SETS    "|"
Temp    SETS    VBar:CC:"FP":CC:"$FPCodeType":CC:"$$$$code|"
        AREA    $Temp,CODE

                        GBLA    ExpectsCoreVersion
ExpectsCoreVersion      SETA    1

; Macros

        MACRO
$label  AdrWS   $reg
$label  ADRL    $reg,FP_Workspace
        MEND

        MACRO
$label  FPInstrDone $opt
        [ "$opt" = ""
$label
        |
$label    TEQ     R9,#0         ;Allow the optimisation, assuming a normal
                                ;  instruction address
        ]
        MEND

        MACRO
$label  Debug0  $mess
$label
        MEND

        MACRO
$label  Debug1  $mess,$reg
$label
        MEND

        MACRO
$label  Debug2  $mess,$reg1,$reg2
$label
        MEND

        MACRO
$label  Debug3  $mess,$reg1,$reg2,$reg3
$label
        MEND

        MACRO
$label  Debug4  $mess,$reg1,$reg2,$reg3,$reg4
$label
        MEND

; Two values used to convert between addresses and branch instructions from
; the undefined instruction vector to that address.

BranchConvertOpcode     EQU     &EA000000
BranchConvertOffset     EQU     Undef_vector + 8 - 0

        END
